searchNodes=[{"doc":"ChromicPDF is a fast HTML-to-PDF/A renderer based on Chrome &amp; Ghostscript.UsageStartStart ChromicPDF as part of your supervision tree:def MyApp.Application do def start(_type, _args) do children = [ # other apps... {ChromicPDF, chromic_pdf_opts()} ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end defp chromic_pdf_opts do [] end endPrint a PDF or PDF/AChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}, output: &quot;output.pdf&quot;)PDF printing comes with a ton of options. Please see ChromicPDF.print_to_pdf/2 and ChromicPDF.convert_to_pdfa/2 for details.Security ConsiderationsBefore adding a browser to your application's (perhaps already long) list of dependencies, you may want consider the security hints below.Escape user-supplied dataMake sure to escape any user-provided data with something like Phoenix.HTML.html_escape. Chrome is designed to make displaying HTML pages relatively safe, in terms of preventing undesired access of a page to the host operating system. However, the attack surface of your application is still increased. Running this in a containerized application with a small RPC interface creates an additional barrier (and has other benefits).Running in offline modeFor some apparent security bonus, browser targets can be spawned in &quot;offline mode&quot; (using the DevTools command Network.emulateNetworkConditions. Chrome targets with network conditions set to offline can't resolve any external URLs (e.g. https://), neither entered as navigation URL nor contained within the HTML body.def chromic_pdf_opts do [offline: true] endChrome Sandbox in Docker containersBy default, ChromicPDF will allow Chrome to make use of its own &quot;sandbox&quot; process jail. The sandbox tries to limit system resource access of the renderer processes to the minimum resources they require to perform their task.However, in Docker containers running Linux images (e.g. images based on Alpine), and which are configured to run their main job as a non-root user, this causes Chrome to crash on startup as it requires root privileges to enter the sandbox.The error output (discard_stderr: false option) looks as follows:Failed to move to new namespace: PID namespaces supported, Network namespace supported, but failed: errno = Operation not permittedThe best way to resolve this issue is to configure your Docker container to use seccomp rules that grant Chrome access to the relevant system calls. See the excellent Zenika/alpine-chrome repository for details on how to make this work.Alternatively, you may choose to disable Chrome's sandbox with the no_sandbox option.defp chromic_pdf_opts do [no_sandbox: true] endSSL connectionsIn you are fetching your print source from a https:// URL, as usual Chrome verifies the remote host's SSL certificate when establishing the secure connection, and errors out of navigation if the certificate has expired or is not signed by a known certificate authority (i.e. no self-signed certificates).For production systems, this security check is essential and should not be circumvented. However, if for some reason you need to bypass certificate verification in development or test, you can do this with the :ignore_certificate_errors option.defp chromic_pdf_opts do [ignore_certificate_errors: true] endWorker poolsChromicPDF spawns two worker pools, the session pool and the ghostscript pool. By default, it will create as many sessions (browser tabs) as schedulers are online, and allow the same number of concurrent Ghostscript processes to run.ConcurrencyTo increase or limit the number of concurrent workers, you can pass pool configuration to the supervisor. Please note that these are non-queueing worker pools. If you intend to max them out, you will need a job queue as well.defp chromic_pdf_opts do [ session_pool: [size: 3] ghostscript_pool: [size: 10] ] endOperation timeoutsBy default, ChromicPDF allows the print process to take 5 seconds to finish. In case you are printing large PDFs and run into timeouts, these can be configured configured by passing the timeout option to the session pool.defp chromic_pdf_opts do [ session_pool: [timeout: 10_000] # in milliseconds ] endAutomatic session restarts to avoid memory drainBy default, ChromicPDF will restart sessions within the Chrome process after 1000 operations. This helps to prevent infinite growth in Chrome's memory consumption. The &quot;max age&quot; of a session can be configured with the :max_session_uses option.defp chromic_pdf_opts do [max_session_uses: 1000] endChrome zombiesHelp, a Chrome army tries to take over my memory!ChromicPDF tries its best to gracefully close the external Chrome process when its supervisor is terminated. Unfortunately, when the BEAM is not shutdown gracefully, Chrome processes will keep running. While in a containerized production environment this is unlikely to be of concern, in development it can lead to unpleasant performance degradation of your operation system.In particular, the BEAM is not shutdown properly…when you exit your application or iex console with the Ctrl+C abort mechanism (see issue #56),and when you run your tests. No, after an ExUnit run your application's supervisor is not terminated cleanly.There are a few ways to mitigate this issue.&quot;On Demand&quot; modeIn case you habitually end your development server with Ctrl+C, you should consider enabling &quot;On Demand&quot; mode which disables the session pool, and instead starts and stops Chrome instances as needed. If multiple PDF operations are requested simultaneously, multiple Chrome processes will be launched (each with a pool size of 1, disregarding the pool configuration).defp chromic_pdf_opts do [on_demand: true] endTo enable it only for development, you can load the option from the application environment.# config/config.exs config :my_app, ChromicPDF, on_demand: false # config/dev.exs config :my_app, ChromicPDF, on_demand: true # application.ex @chromic_pdf_opts Application.compile_env!(:my_app, ChromicPDF) defp chromic_pdf_opts do @chromic_pdf_opts ++ [... other opts ...] endTerminating your supervisor after your test suiteYou can enable &quot;On Demand&quot; mode for your tests, as well. However, please be aware that each test that prints a PDF will have an increased runtime (plus about 0.5s) due to the added Chrome boot time cost. Luckily, ExUnit provides a method to run code at the end of your test suite.# test/test_helper.exs ExUnit.after_suite(fn _ -&gt; Supervisor.stop(MyApp.Supervisor) end) ExUnit.start()Only start ChromicPDF in productionThe easiest way to prevent Chrome from spawning in development is to only run ChromicPDF in the prod environment. However, obviously you won't be able to print PDFs in development or test then.Chrome OptionsCustom command line switchesThe :chrome_args option allows to pass arbitrary options to the Chrome/Chromium executable.defp chromic_pdf_opts do [chrome_args: &quot;--font-render-hinting=none&quot;] endThe :chrome_executable option allows to specify a custom Chrome/Chromium executable.defp chromic_pdf_opts do [chrome_executable: &quot;/usr/bin/google-chrome-beta&quot;] endDebugging Chrome errorsChrome's stderr logging is silently discarded to not obscure your logfiles. In case you would like to take a peek, add the discard_stderr: false option.defp chromic_pdf_opts do [discard_stderr: false] endTelemetry supportTo provide insights into PDF and PDF/A generation performance, ChromicPDF executes the following telemetry events:[:chromic_pdf, :print_to_pdf, :start | :stop | exception][:chromic_pdf, :capture_screenshot, :start | :stop | :exception][:chromic_pdf, :convert_to_pdfa, :start | :stop | exception]Please see :telemetry.span/3 for details on their payloads, and :telemetry.attach/4 for how to attach to them.Each of the corresponding functions accepts a telemetry_metadata option which is passed to the attached event handler. This can, for instance, be used to mark events with custom tags such as the type of the print document.ChromicPDF.print_to_pdf(..., telemetry_metadata: %{template: &quot;invoice&quot;})The print_to_pdfa function emits both the print_to_pdf and convert_to_pdfa event series, in that order.How it worksPDF PrintingChromicPDF spawns an instance of Chromium/Chrome (an OS process) and connects to its &quot;DevTools&quot; channel via file descriptors.The Chrome process is supervised and the connected processes will automatically recover if it crashes.A number of &quot;targets&quot; in Chrome are spawned, 1 per worker process in the SessionPool. By default, ChromicPDF will spawn each session in a new browser context (i.e., a profile).When a PDF print is requested, a session will instruct its assigned &quot;target&quot; to navigate to the given URL, then wait until it receives a &quot;frameStoppedLoading&quot; event, and proceed to call the printToPDF function.The printed PDF will be sent to the session as Base64 encoded chunks.PDF/A ConversionTo convert a PDF to a PDF/A-3, ChromicPDF uses the ghostscript utility.Since it is required to embed a color scheme into PDF/A files, ChromicPDF ships with a copy of the royalty-free eciRGB_V2 scheme by the European Color Initiative. If you need to be able to use a different color scheme, please open an issue.","ref":"ChromicPDF.html","title":"ChromicPDF","type":"module"},{"doc":"Captures a screenshot.This call blocks until the screenshot has been created.Print and return Base64-encoded PNG{:ok, blob} = ChromicPDF.capture_screenshot({:url, &quot;file:///example.html&quot;})OptionsOptions to the Page.captureScrenshot call can be passed by passing a map to the :capture_screenshot option.ChromicPDF.capture_screenshot( {:url, &quot;file:///example.html&quot;}, capture_screenshot: %{ format: &quot;jpeg&quot; } )For navigational options (source, cookies, evaluating scripts) see print_to_pdf/2.","ref":"ChromicPDF.html#capture_screenshot/2","title":"ChromicPDF.capture_screenshot/2","type":"function"},{"doc":"Returns a specification to start this module as part of a supervision tree.","ref":"ChromicPDF.html#child_spec/1","title":"ChromicPDF.child_spec/1","type":"function"},{"doc":"Converts a PDF to PDF/A (either PDF/A-2b or PDF/A-3b).Convert an input PDF and return a Base64-encoded blob{:ok, blob} = ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;)Convert and write to fileChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, output: &quot;output.pdf&quot;)PDF/A versions &amp; levelsGhostscript supports both PDF/A-2 and PDF/A-3 versions, both in their b (basic) level. By default, ChromicPDF generates version PDF/A-3b files. Set the pdfa_version option for version 2.ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, pdfa_version: &quot;2&quot;)Specifying PDF metadataThe converter is able to transfer PDF metadata (the Info dictionary) from the original PDF file to the output file. However, files printed by Chrome do not contain any metadata information (except &quot;Creator&quot; being &quot;Chrome&quot;).The :info option of the PDF/A converter allows to specify metatadata for the output file directly.ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, info: %{creator: &quot;ChromicPDF&quot;})The converter understands the following keys, all of which accept only String values::title:author:subject:keywords:creator:creation_date:mod_dateBy specification, date values in :creation_date and :mod_date do not need to follow a specific syntax. However, Ghostscript inserts date strings like &quot;D:20200208153049+00'00'&quot; and Info extractor tools might rely on this or another specific format. The converter will automatically format given DateTime values like this.Both :creation_date and :mod_date are filled with the current date automatically (by Ghostscript), if the original file did not contain any.Adding more PostScript to the conversionThe pdfa_def_ext option can be used to feed more PostScript code into the final conversion step.ChromicPDF.convert_to_pdfa( &quot;some_pdf_file.pdf&quot;, pdfa_def_ext: &quot;[/Title (OverriddenTitle) /DOCINFO pdfmark&quot;, )","ref":"ChromicPDF.html#convert_to_pdfa/2","title":"ChromicPDF.convert_to_pdfa/2","type":"function"},{"doc":"Prints a PDF.This call blocks until the PDF has been created.Output optionsPrint and return Base64-encoded PDF{:ok, blob} = ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}) # Can be displayed in iframes &quot;data:application/pdf;base64,\\\#{blob}&quot;Print to file:ok = ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}, output: &quot;output.pdf&quot;)Print to temporary file{:ok, :some_result} = ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}, output: fn path -&gt; send_download(path) :some_result end)The temporary file passed to the callback will be deleted when the callback returns.Input optionsChromicPDF offers two primary methods of supplying Chrome with the HTML source to print. You can choose between passing in an URL for Chrome to load and injecting the HTML markup directly into the DOM through the remote debugging API.Print from URLPassing in a URL is the simplest way of printing a PDF. A target in Chrome is told to navigate to the given URL. When navigation is finished, the PDF is printed.ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}) ChromicPDF.print_to_pdf({:url, &quot;http:///example.net&quot;}) ChromicPDF.print_to_pdf({:url, &quot;https:///example.net&quot;})CookiesIf your URL requires authentication, you can pass in a session cookie. The cookie is automatically cleared after the PDF has been printed.cookie = %{ name: &quot;foo&quot;, value: &quot;bar&quot;, domain: &quot;localhost&quot; } ChromicPDF.print_to_pdf({:url, &quot;http:///example.net&quot;}, set_cookie: cookie)See Network.setCookie for options. name and value keys are required.Print from in-memory HTMLAlternatively, print_to_pdf/2 allows to pass an in-memory HTML blob to Chrome in a {:html, blob()} tuple. The HTML is sent to the target using the Page.setDocumentContent function. Oftentimes this method is preferable over printing a URL if you intend to render PDFs from templates rendered within the application that also hosts ChromicPDF, without the need to route the content through an actual HTTP endpoint. Also, this way of passing the HTML source has slightly better performance than printing a URL.ChromicPDF.print_to_pdf( {:html, &quot;&lt;h1&gt;Hello World!&lt;/h1&gt;&quot;} )In-memory content can be iodataIn-memory HTML for both the main input parameter as well as the header and footer options can be passed as iodata. Such lists are converted to String before submission to the session process by passing them through :erlang.iolist_to_binary/1.ChromicPDF.print_to_pdf( {:html, [&quot;&lt;style&gt;p { color: green; }&lt;/style&gt;&quot;, &quot;&lt;p&gt;green paragraph&lt;/p&gt;&quot;]} )CaveatsPlease mind the following caveats.References to external files in HTML sourcePlease note that since the document content is replaced without navigating to a URL, Chrome has no way of telling which host to prepend to relative URLs contained in the source. This means, if your HTML contains markup like&lt;!-- BAD: relative link to stylesheet in &lt;head&gt; element --&gt; &lt;head&gt; &lt;link rel=&quot;stylesheet&quot; href=&quot;selfhtml.css&quot;&gt; &lt;/head&gt; &lt;!-- BAD: relative link to image --&gt; &lt;img src=&quot;some_logo.png&quot;&gt;... you will need to replace these lines with either absolute URLs or inline data. Of course, absolute URLs can use the file:// scheme to point to files on the local filesystem, assuming Chrome has access to them. For the purpose of displaying small inline images (e.g. logos), data URLs are a good way of embedding them without the need for an absolute URL.&lt;!-- GOOD: inline styles --&gt; &lt;style&gt; /* ... */ &lt;/style&gt; &lt;!-- GOOD: data URLs --&gt; &lt;img src=&quot;data:image/png;base64,R0lGODdhEA...&quot;&gt; &lt;!-- GOOD: absolute URLs --&gt; &lt;img src=&quot;http://localhost/path/to/image.png&quot;&gt; &lt;img src=&quot;file:///path/to/image.png&quot;&gt;Content from Phoenix templatesIf your content is generated by a Phoenix template (and hence comes in the form of {:safe, iodata()}), you will need to pass it to Phoenix.HTML.safe_to_string/1 first.content = SomeView.render(&quot;body.html&quot;) |&gt; Phoenix.HTML.safe_to_string() ChromicPDF.print_to_pdf({:html, content})PDF printing optionsChromicPDF.print_to_pdf( {:url, &quot;file:///example.html&quot;}, print_to_pdf: %{ # Margins are in given inches marginTop: 0.393701, marginLeft: 0.787402, marginRight: 0.787402, marginBottom: 1.1811, # Print header and footer (on each page). # This will print the default templates if none are given. displayHeaderFooter: true, # Even on empty string. # To disable header or footer, pass an empty element. headerTemplate: &quot;&lt;span&gt;&lt;/span&gt;&quot;, # Example footer template. # They are completely unstyled by default and have a font-size of zero, # so don&#39;t despair if they don&#39;t show up at first. # There&#39;s a lot of documentation online about how to style them properly, # this is just a basic example. Also, take a look at the documentation for the # ChromicPDF.Template module. # The &lt;span&gt; classes shown below are interpolated by Chrome. footerTemplate: &quot;&quot;&quot; &lt;style&gt; p { color: #333; font-size: 10pt; text-align: right; margin: 0 0.787402in; width: 100%; z-index: 1000; } &lt;/style&gt; &lt;p&gt; Page &lt;span class=&quot;pageNumber&quot;&gt;&lt;/span&gt; of &lt;span class=&quot;totalPages&quot;&gt;&lt;/span&gt; &lt;/p&gt; &quot;&quot;&quot; } )Please note the camel-case. For a full list of options to the printToPDF function, please see the Chrome documentation at:https://chromedevtools.github.io/devtools-protocol/tot/Page#method-printToPDFPage size and marginsChrome will use the provided pagerWidth and paperHeight dimensions as the PDF paper format. Please be aware that the @page section in the body CSS is not correctly interpreted, see ChromicPDF.Template for a discussion.Header and footerChrome's support for native header and footer sections is a little bit finicky. Still, to the best of my knowledge, Chrome is currently the only well-functioning solution for HTML-to-PDF conversion if you need headers or footers that are repeated on multiple pages even in the presence of body elements stretching across a page break.In order to make header and footer visible in the first place, you will need to be aware of a couple of caveats:HTML for header and footer is interpreted in a new page context which means no body styles will be applied. In fact, even default browser styles are not present, so all content will have a default font-size of zero, and so on.You need to make space for the header and footer templates first, by adding page margins. Margins can either be given using the marginTop and marginBottom options or with CSS styles. If you use the options, the height of header and footer elements will inherit these values. If you use CSS styles, make sure to set the height of the elements in CSS as well.Header and footer have a default padding to the page ends of 0.4 centimeters. To remove this, add the following to header/footer template styles (source).#header, #footer { padding: 0 !important; }Header and footer have a default zoom level of 1/0.75 so everything appears to be smaller than in the body when the same styles are applied.If header or footer are not displayed even though they should, make sure your HTML is valid. Tuning the margins for an hour looking for mistakes there, only to discover that you are missing a closing &lt;/style&gt; tag, can be quite painful.Javascript is not interpreted.Background colors are not applied unless you include -webkit-print-color-adjust: exact in your stylesheet.See print_header_footer_template.html from the Chromium sources to see how these values are interpreted.Dynamic ContentEvaluate script before printingIn case your print source is generated by client-side scripts, for instance to render graphics or load additional resources, you can trigger these by evaluating a JavaScript expression before the PDF is printed.evaluate = %{ expression: &quot;&quot;&quot; document.querySelector(&#39;body&#39;).innerHTML = &#39;hello world&#39;; &quot;&quot;&quot; } ChromicPDF.print_to_pdf({:url, &quot;http://example.net&quot;}, evaluate: evaluate)If your script returns a Promise, Chrome will wait for it to be resolved.Wait for attribute on elementSome JavaScript libraries signal their successful initialization to the user by setting an attribute on a DOM element. The wait_for option allows you to wait for this attribute to be set before printing. It evaluates a script that repeatedly queries the element given by the query selector and tests whether it has the given attribute.wait_for = %{ selector: &quot;#my-element&quot;, attribute: &quot;ready-to-print&quot; } ChromicPDF.print_to_pdf({:url, &quot;http:///example.net&quot;}, wait_for: wait_for)","ref":"ChromicPDF.html#print_to_pdf/2","title":"ChromicPDF.print_to_pdf/2","type":"function"},{"doc":"Prints a PDF and converts it to PDF/A in a single call.See print_to_pdf/2 and convert_to_pdfa/2 for options.ExampleChromicPDF.print_to_pdfa({:url, &quot;https://example.net&quot;})","ref":"ChromicPDF.html#print_to_pdfa/2","title":"ChromicPDF.print_to_pdfa/2","type":"function"},{"doc":"Starts ChromicPDF.If the given config includes the on_demand: true flag, this will instead spawn an Agent process that holds this configuration until a PDF operation is triggered which will then launch a supervisor temporarily, process the operation, and proceed to perform a graceful shutdown.","ref":"ChromicPDF.html#start_link/1","title":"ChromicPDF.start_link/1","type":"function"},{"doc":"","ref":"ChromicPDF.html#t:blob/0","title":"ChromicPDF.blob/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:capture_screenshot_option/0","title":"ChromicPDF.capture_screenshot_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:evaluate_option/0","title":"ChromicPDF.evaluate_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:ghostscript_pool_option/0","title":"ChromicPDF.ghostscript_pool_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:global_option/0","title":"ChromicPDF.global_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:info_option/0","title":"ChromicPDF.info_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:navigate_option/0","title":"ChromicPDF.navigate_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:output_function/0","title":"ChromicPDF.output_function/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:output_function_result/0","title":"ChromicPDF.output_function_result/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:output_option/0","title":"ChromicPDF.output_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:path/0","title":"ChromicPDF.path/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:pdf_option/0","title":"ChromicPDF.pdf_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:pdfa_option/0","title":"ChromicPDF.pdfa_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:return/0","title":"ChromicPDF.return/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:session_pool_option/0","title":"ChromicPDF.session_pool_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:source/0","title":"ChromicPDF.source/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:source_and_options/0","title":"ChromicPDF.source_and_options/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:telemetry_metadata_option/0","title":"ChromicPDF.telemetry_metadata_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:url/0","title":"ChromicPDF.url/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:wait_for_option/0","title":"ChromicPDF.wait_for_option/0","type":"type"},{"doc":"Use this for multiple ChromicPDF instances.When is this useful?You want to completely separate two or more PDF worker poolsYou want to give your PDF module a custom APIUsagedefmodule MyApp.MyPDFGenerator do use ChromicPDF.Supervisor end def MyApp.Application do def start(_type, _args) do children = [ MyApp.MyPDFGenerator ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end end","ref":"ChromicPDF.Supervisor.html","title":"ChromicPDF.Supervisor","type":"module"},{"doc":"Returns a specification to start this module as part of a supervision tree.","ref":"ChromicPDF.Supervisor.html#child_spec/2","title":"ChromicPDF.Supervisor.child_spec/2","type":"function"},{"doc":"Fetches pids of the supervisor's services and passes them to the given callback function.If the supervisor has not been started but configured to run in on_demand mode, this will start a temporary supervision tree.","ref":"ChromicPDF.Supervisor.html#with_services/2","title":"ChromicPDF.Supervisor.with_services/2","type":"function"},{"doc":"","ref":"ChromicPDF.Supervisor.html#t:services/0","title":"ChromicPDF.Supervisor.services/0","type":"type"},{"doc":"Helper functions for page styling.For a start, see source_and_options/1.MotivationThis module contains helper functions that make it easier to to build HTML templates (body, header, and footer) that fully cover a given page. Like an adapter, it tries to harmonize Chrome's printToPDF options and related CSS layout styles (@page and friends) with a custom set of page sizing options. Using this module is entirely optional, but perhaps can help to avoid some common pitfalls arising from the slightly unintuitive and sometimes conflicting behaviour of printToPDF options and @page CSS styles in Chrome.Page dimensionsOne particularly cumbersome detail is that Chrome in headless mode does not correctly interpret the @page CSS rule to configure the page dimensions. Resulting PDF files will always be in US-letter format unless configured differently with the paperWidth and paperHeight options. Experience has shown, that results will be best if the @page rule aligns with the values passed to printToPDF/2, which is why this module exists to make basic page sizing easier.","ref":"ChromicPDF.Template.html","title":"ChromicPDF.Template","type":"module"},{"doc":"Concatenes two HTML strings or iolists into one.From {:safe, iolist} tuples, the :safe is dropped. This is useful to prepare data coming from a Phoenix-compiled .eex template.content = html_concat(@styles, render(&quot;content.html&quot;))","ref":"ChromicPDF.Template.html#html_concat/2","title":"ChromicPDF.Template.html_concat/2","type":"function"},{"doc":"Returns source and options for a PDF to be printed, a given set of template options. The return value can be passed to ChromicPDF.print_to_pdf/2.Optionsheaderfooterall options from styles/1ExampleThis example has the dimension of a ISO A4 page.ChromicPDF.Template.source_and_options( content: &quot;&lt;p&gt;Hello&lt;/p&gt;&quot;, header: &quot;&lt;p&gt;header&lt;/p&gt;&quot;, footer: &quot;&lt;p&gt;footer&lt;/p&gt;&quot; size: :a4, header_height: &quot;45mm&quot;, header_font_size: &quot;20pt&quot;, footer_height: &quot;40mm&quot; )Content, header, and footer templates should be unwrapped HTML markup (i.e. no &lt;html&gt; around the content), prefixed with any &lt;style&gt; tags that your page needs. &lt;style&gt; h1 { font-size: 22pt; } &lt;/style&gt; &lt;h1&gt;Hello&lt;/h1&gt;⚠ Markup is injected into the DOM ⚠Please be aware that the options returned by this function cause ChromicPDF to inject the markup directly into the DOM using the remote debugging API. This comes with some pitfalls which are explained in ChromicPDF.print_to_pdf/2. Most notably, no relative URLs may be used within the given HTML.","ref":"ChromicPDF.Template.html#source_and_options/1","title":"ChromicPDF.Template.source_and_options/1","type":"function"},{"doc":"Renders page styles for given options.These base styles will configure page dimensions and header and footer heights. They also remove any browser padding and margins from these elements, and set the font-size.Additionally, they set the zoom level of header and footer templates to 0.75 which seems to make them align with the content viewport scaling better.Optionssize page size, either a standard name (:a4, :us_letter) or a {&lt;width&gt;, &lt;height&gt;} tuple in inches, default: :us_letterheader_height default: zeroheader_font_size default: 10ptheader_zoom default: 0.75footer_height default: zerofooter_font_size default: 10ptfooter_zoom default: 0.75webkit_color_print_adjust default: &quot;exact&quot;","ref":"ChromicPDF.Template.html#styles/1","title":"ChromicPDF.Template.styles/1","type":"function"},{"doc":"","ref":"ChromicPDF.Template.html#t:blob/0","title":"ChromicPDF.Template.blob/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:content_option/0","title":"ChromicPDF.Template.content_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:paper_size/0","title":"ChromicPDF.Template.paper_size/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:style_option/0","title":"ChromicPDF.Template.style_option/0","type":"type"},{"doc":"Exception in the communication with Chrome.","ref":"ChromicPDF.ChromeError.html","title":"ChromicPDF.ChromeError","type":"exception"},{"doc":"Exception raised when Chrome process has stopped unexpectedly.","ref":"ChromicPDF.Connection.ConnectionLostError.html","title":"ChromicPDF.Connection.ConnectionLostError","type":"exception"},{"doc":"ChromicPDF is a HTML-to-PDF renderer for Elixir, based on headless Chrome.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Node-free: In contrast to many other packages, it does not use puppeteer, and hence does not require Node.js. It communicates directly with Chrome's DevTools API over pipes, offering the same performance as puppeteer, if not better.Header/Footer: Using the DevTools API allows to apply the full set of options of the printToPDF function. Most notably, it supports header and footer HTML templates.PDF/A: It can convert printed files to PDF/A using Ghostscript, inspired by the pdf2archive script originally created by @matteosecli and later enhanced by @JaimeChavarriaga. Created PDF/A-2b and PDF/A-3b files pass the verapdf compliance checks.","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"Chromium or ChromeGhostscript (optional, for PDF/A support)","ref":"readme.html#requirements","title":"README - Requirements","type":"extras"},{"doc":"ChromicPDF is a supervision tree (rather than an application). You will need to inject it into the supervision tree of your application. First, add ChromicPDF to your runtime dependencies:def deps do [ {:chromic_pdf, &quot;~&gt; 1.1&quot;} ] endNext, start ChromicPDF as part of your application:# lib/my_app/application.ex def MyApp.Application do def start(_type, _args) do children = [ # other apps... ChromicPDF ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Main APIHere's how you generate a PDF from an external URL and store it in the local filesystem.# Prints a local HTML file to PDF. ChromicPDF.print_to_pdf({:url, &quot;https://example.net&quot;}, output: &quot;example.pdf&quot;)The next example shows how to print a local HTML file to PDF/A, as well as the use of a callback function that receives the generated PDF as path to a temporary file.ChromicPDF.print_to_pdfa({:url, &quot;file:///example.html&quot;}, output: fn pdf -&gt; # Send pdf via mail, upload to S3, ... end)Template APIChromicPDF.Template contains additional functionality that makes styling of PDF documents easier and overall provides a more convenient API. See the documentation for details.[content: &quot;&lt;p&gt;Hello Template&lt;/p&gt;&quot;] |&gt; ChromicPDF.Template.source_and_options() |&gt; ChromicPDF.print_to_pdf()ExamplesFor a more complete example of how to integrate ChromicPDF in a Phoenix application, see examples/phoenix.","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"For running the full suite of integration tests, please install and have in your $PATH:verapdfFor pdfinfo and pdftotext, you need poppler-utils (most Linux distributions) or Xpdf (OSX)For the odd ZUGFeRD test in zugferd_test.exs, you need to download ZUV and set the $ZUV_JAR environment variable.","ref":"readme.html#development","title":"README - Development","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"AddedRelaxed telemetry dependency to avoid blocking dependency update (@leandrocp)Add chromium path on macOS when installed via homebrew (@shamanime)","ref":"changelog.html#1-1-1-2021-09-24","title":"Changelog - [1.1.1] - 2021-09-24","type":"extras"},{"doc":"ChangedImproved error message when Chrome dies at startup.Improved docs on the no_sandbox option.AddedAdded chrome_executable option to allow specifying path to chrome executable.","ref":"changelog.html#1-1-0-2021-04-16","title":"Changelog - [1.1.0] - 2021-04-16","type":"extras"},{"doc":"AddedAdded evaluate option to run client-side scripts before printing.Added a few options (evaluate, set_cookie, wait_for) to capture_screenshot/2.ChangedReimplemented wait_for option based on a JS script and the evaluate option to overcome race condition issues of original solution. Behaviour remains the same.","ref":"changelog.html#1-0-0-2021-03-23","title":"Changelog - [1.0.0] - 2021-03-23","type":"extras"},{"doc":"FixedEnforced telemetry version 0.4.2 (fixes #108)","ref":"changelog.html#0-7-2-2021-02-26","title":"Changelog - [0.7.2] - 2021-02-26","type":"extras"},{"doc":"FixedTo determine the session pool / ghostscript pool size, if not specified in the options, we now fetch the number of schedulers at runtime, not compile time. Makes more sense. We also set a minimum of 1 in case there is only 1 scheduler online.","ref":"changelog.html#0-7-1-2021-02-08","title":"Changelog - [0.7.1] - 2021-02-08","type":"extras"},{"doc":"AddedAdded option wait_for to wait for DOM element attribute to be set dynamically. (@jarimatti)New global timeout option for session pool allows to configure timeout of print processes.New global ignore_certificate_errors option allows to bypass SSL certificate verification.New global chrome_args option allows to pass custom flags to chrome command.","ref":"changelog.html#0-7-0-2021-01-25","title":"Changelog - [0.7.0] - 2021-01-25","type":"extras"},{"doc":"FixedWhen sending HTML to Chrome with {:html, &lt;content&gt;}, wait for the Page.loadEventFired notification to allow external resources (images, scripts, ...) to be fetched. (#80)","ref":"changelog.html#0-6-2-2020-12-28","title":"Changelog - [0.6.2] - 2020-12-28","type":"extras"},{"doc":"FixedReverted to file descriptor redirection to mitigate weird Port behaviour (#76).","ref":"changelog.html#0-6-1-2020-11-17","title":"Changelog - [0.6.1] - 2020-11-17","type":"extras"},{"doc":"ChangedElixir version housekeeping. Fixed a warning on Elixir 1.11 by adding :eex to :extra_applications. ChromicPDF now requires Elixir &gt;= 1.10 for its use of Application.compile_env/3.Dropped poolboy in favour of nimble_pool. This renders the max_overflow poolboy option without effect.Made &quot;online mode&quot; the default. Chrome will resolve all URL references unless the global option offline: false is set.AddedAdded telemetry events for the PDF generation &amp; PDF/A conversion.&quot;On Demand&quot; mode allows to start &amp; stop Chrome as needed, much like puppeteer does. This helps in development to prevent leaving behind zombie processes when the BEAM is aborted with Ctrl+C.New global option discard_stderr allows to enable Chrome's stderr logging which is by default piped to /dev/null.FixedGraceful shutdown is now actually graceful in that it waits for Chrome to clean up the debugging sessions and close the pipe on its end.","ref":"changelog.html#0-6-0-2020-11-16","title":"Changelog - [0.6.0] - 2020-11-16","type":"extras"},{"doc":"FixedMoved static files required for PDF/A generation to /priv so they are embedded into releases.Moved logo files out of /priv so they are not included in releases.","ref":"changelog.html#0-5-2-2020-07-17","title":"Changelog - [0.5.2] - 2020-07-17","type":"extras"},{"doc":"FixedFixed typespecs for Template.source_and_options/1. [content_option] weren't allowed as call to styles/1 narrowed type to [style_option].Added missing keys to style_option.","ref":"changelog.html#0-5-1-2020-07-10","title":"Changelog - [0.5.1] - 2020-07-10","type":"extras"},{"doc":"ChangedRemoved the :width and :height options from Template.styles/1 and Template.source_and_options/1 as it turns out that Chrome does not pay attention to @page dimensions and instead still sets the size of the produced PDF to US letter. Since it does not seem possible to the PDF size in Chrome headless besides using the paperWidth and paperHeight options, moved to a :size option instead that accepts names like :a4, :us_letter, and tuples of {&lt;width&gt;, &lt;height&gt;} in inches. These are then passed to paperWidth and paperHeight.Ditched the preferCssPageSize option from Template.source_and_options/1 as it did not seem to have any effect. See above.AddedAdded zoom: 0.75 to both #header and #footer in the template as this seems to be exactly what is needed to reverse the viewport scaling that Chrome uses on them by default. With this, headers &amp; footers and the content can use the same CSS styles.Included -webkit-print-color-adjust: exact rule to template so background-color rules are enabled by default.FixedMake print_to_pdfa/2 actually accept source_and_options() map from Template.","ref":"changelog.html#0-5-0-2020-07-10","title":"Changelog - [0.5.0] - 2020-07-10","type":"extras"},{"doc":"AddedAllow {:url, &lt;path&gt;} input tuples where path is only a path, and not a file:// URL.ChangedWhen passing a function to the :output parameter, the function result will now be returned as part of the print_to_pdf &amp; friends result as {:ok, &lt;callback_result&gt;} instead of :ok.","ref":"changelog.html#0-4-0-2020-07-09","title":"Changelog - [0.4.0] - 2020-07-09","type":"extras"},{"doc":"AddedHandle {:safe, iolist()} tuples in API and Template (for content coming from Phoenix.View). Expose Template.html_concat as potentially useful helper.Reset navigation history after each print job to avoid leaking information.Create new empty browser context for each target (similar to incognito tab).Restart browser target after a maximum number of PDFs have been printed to avoid memory bloat.ChangedSet user agent to custom string.Default number of sessions in pool to half the number of available cores.","ref":"changelog.html#0-3-1-2020-04-09","title":"Changelog - [0.3.1] - 2020-04-09","type":"extras"},{"doc":"AddedHTML source and header and footer template accept iolists nowNew Template module contains basic CSS skeleton to easily dimension &amp; layout pages (header &amp; footer margins)","ref":"changelog.html#0-3-0-2020-03-30","title":"Changelog - [0.3.0] - 2020-03-30","type":"extras"},{"doc":"AddedAdd set_cookie option to print_to_pdf/2.Targets now navigate to about:blank after PDF prints.Fixed the temporary file yielding way of calling print_to_pdf/2.","ref":"changelog.html#0-2-0-2020-03-06","title":"Changelog - [0.2.0] - 2020-03-06","type":"extras"},{"doc":"AddedFirst release to hex.pm","ref":"changelog.html#0-1-0-2020-03-02","title":"Changelog - [0.1.0] - 2020-03-02","type":"extras"}]